<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Map extends Controller_UserEnvi {
    
    public function action_show()
    {
        $twig = Twig::factory('teacher/map/show');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $discipline = $this->model->getDisciplineMap($this->UserInfo['TeacherID'], $id);
        if(count($discipline) == 0)
            throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
        $disciplineHandled = array();
        $maxRate = 0; $i = 0; $module = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if(!isset($disciplineHandled[$i]['SubmodulesCount']))
            {
                $disciplineHandled[$i]['SubmodulesCount'] = 0;
                $disciplineHandled[$i]['MaxRate'] = 0;
            }
            $j = $disciplineHandled[$i]['SubmodulesCount'] += 1;
            $disciplineHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $disciplineHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $disciplineHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $disciplineHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $disciplineHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['MaxRate'] = (int) $maxRate;        
        
        $this->response->body($twig);
    }
    
    public function action_create()
    {
        $twig = Twig::factory('teacher/map/construct');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        
        $this->response->body($twig);
    }
    
    public function action_edit()
    {
        $twig = Twig::factory('teacher/map/construct');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $discipline = $this->model->getDisciplineMap($this->UserInfo['TeacherID'], $id);
        if(count($discipline) == 0)
            throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
        $disciplineHandled = array();
        $maxRate = 0; $i = 0; $module = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if(!isset($disciplineHandled[$i]['SubmodulesCount']))
            {
                $disciplineHandled[$i]['SubmodulesCount'] = 0;
                $disciplineHandled[$i]['MaxRate'] = 0;
            }
            $j = $disciplineHandled[$i]['SubmodulesCount'] += 1;
            $disciplineHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $disciplineHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $disciplineHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $disciplineHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $disciplineHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['MaxRate'] = (int) $maxRate;           
        $this->response->body($twig);
    }
}
            